/******************************************************************************
 *
 *		pcm8pp C Header file
 *
 ******************************************************************************/

#ifndef __pcm8pp_h__

#define __pcm8pp_h__


#define 	VOLUME_NOT_CHANGE	0xFF0000
#define		VOLUME_SIZE_8		0x080000

#define		STEREO_16bit_48_0	0x001e00
#define		STEREO_16bit_44_1	0x001d00
#define		STEREO_16bit_32_0	0x001c00
#define		STEREO_16bit_24_0	0x001b00

#define		OUTPUT_PAN_L		0x000001
#define		OUTPUT_PAN_R		0x000002
#define		OUTPUT_PAN_LR		0x000003


#define		OUTPUT_32_0			0x00
#define		OUTPUT_44_1			0x01
#define		OUTPUT_48_0			0x02

int iPcm8Play(	int 	iChannel,
				int 	iFormat,
				int		iLength,
				char	*pcData );


int	iPcm8Stat(	int		iChannel );

int iPcm8Stop( void );

int iPcm8Pause( void );

int	iPcm8Restart( void );

int	iPcm8SetOutHz( int iType );

#endif
