#include <method\methodSx.h>
#include <sxlib.h>
#include "pcm8pp.h"
#include "spsx.h"

remote extern	stPlayList_t	stPlayList;			/* Đt@C̈ꗗ̍\ */
extern	int				iPlayMode;

uchar		acFileName[256];			/* Đt@C				 		*/
int			iPlayFlag;					/* ĐtOiPȁj( 0:ĐI 1:Đ)		*/
int			iIsPlaying;					/* ĐtOiŚj */

int			iPlayTrack;
uchar		*pcPlayTitle;

/* {^pC[W̃|C^ */
extern rectImg **pImgPlayButton;			/* Đ{^ */
extern rectImg **pImgStopButton;			/* ~{^ */
extern rectImg **pImgNextButton;			/* ȃ{^ */
extern rectImg	**pImgBeforeButton;			/* Oȃ{^ */
extern rectImg **pImgRandomButton;			/* _{^ */
extern rectImg **pImgPauseButton;			/* ꎞ~{^ */
extern rectImg **pImgRestartButton;		/* ĊJ{^ */
extern rectImg **pImgDisRndButton;			/* _{^ */
extern rectImg **pImgPushPlayButton;		/* Đ{^ */
extern rectImg **pImgPushStopButton;		/* ~{^ */
extern rectImg **pImgPushNextButton;		/* ȃ{^ */
extern rectImg **pImgPushBeforeButton;		/* Oȃ{^ */
extern rectImg **pImgPushRndButton;		/* _{^ */
extern rectImg **pImgPushPauseButton;		/* ꎞ~{^ */
extern rectImg **pImgPushRestartButton;	/* ĊJ{^ */
extern rectImg	**pImgPushDisRndButton;		/* _{^ */


extern rectImg **pImageH[5];		/* C[W{^ziʏ{^j     */
extern rectImg **pImageL[5];		/* @@@@@@@@@iĂ鎞j */

extern method_t	mCtrlButton;

extern job_t jobPcmPlay;

int iPlayCtrlMain(tsevent *ts);
int	iPlayCtrlInit(tsevent *ts);
int iPlayCtrlEnd(tsevent *ts);
int iPlayCtrlPause(tsevent *ts);
int	iPlayCtrlRestart(tsevent *ts);

job_t	jobPlayCtrl = {
						NULL,
						iPlayCtrlMain,
						iPlayCtrlInit,
						iPlayCtrlEnd,
						iPlayCtrlPause,
						iPlayCtrlRestart,
						0 };


int	iPlayCtrlMain(tsevent *ts)
{
	int		i;

	if ( iPlayFlag == 0 ) {
 		if ( stPlayList.iPlayCount < stPlayList.iMusicCount) {

			if ( iPlayMode == PLAY_RANDOM ) {
				i = rand() % stPlayList.iMusicCount;
				while ( stPlayList.pstPlayList[i].iPlayFlag ) {
					i = rand() % stPlayList.iMusicCount;
				}
				stPlayList.pstPlayList[i].iPlayFlag = 1;
			}
			else {
				i = stPlayList.iPlayingNo;
			}

			strcpy(acFileName,stPlayList.pstPlayList[i].acFileName);

			iPlayFlag = 1;
			
			ChainAJob(0,&jobPcmPlay);	

			stPlayList.iPlayCount++;
			stPlayList.iPlayingNo = i + 1;

			iPlayTrack = i + 1;
			iDrawTrack();

			pcPlayTitle = stPlayList.pstPlayList[i].acTitle;
			iDrawTitle();
		}
		else {
			UnchainJob();
			return 0;
		}
	}

	return 0;
}

int	iPlayCtrlInit(tsevent *ts)
{
	int	i;

	pImageH[0] = pImgPauseButton;
	pImageL[0] = pImgPushPauseButton;
	DrawAPM(&mCtrlButton,0);
	iPlayFlag = 0;


	for ( i = 0; i < stPlayList.iMusicCount; i++ ) {
		stPlayList.pstPlayList[i].iPlayFlag = 0;
	}


	return 0;
}

int	iPlayCtrlEnd(tsevent *ts)
{

	iPlayFlag = 0;
	iIsPlaying = 0;

	pImageH[0] = pImgPlayButton;
	pImageL[0] = pImgPushPlayButton;
	DrawAPM(&mCtrlButton,0);

	iPlayMode = PLAY_NORMAL;


	if ( stPlayList.iMusicCount > 0 ) {
		iPlayTrack = 1;
		pcPlayTitle = stPlayList.pstPlayList[0].acTitle;
	}
	else {
		iPlayTrack = 0;
		pcPlayTitle = NULL;
	}

	iDrawTrack();
	iDrawTitle();

	stPlayList.iPlayCount = 0;
	stPlayList.iPlayingNo = 0;

	return 0;
}

int	iPlayCtrlPause(tsevent *ts)
{
	SleepJob(&jobPcmPlay);
	pImageH[0] = pImgRestartButton;
	pImageL[0] = pImgPushRestartButton;
	DrawAPM(&mCtrlButton,0);

	return 0;
}

int	iPlayCtrlRestart(tsevent *ts)
{
	AwakeJob(&jobPcmPlay);
	pImageH[0] = pImgPauseButton;
	pImageL[0] = pImgPushPauseButton;
	DrawAPM(&mCtrlButton,0);

	return 0;
}
