#include <method\methodSx.h>
#include <sxlib.h>
#include "pcm8pp.h"
#include "spsx.h"


int MainDraw();

proc_list_t							/* `惋[`Xg */
	mainDraw = {MainDraw, NULL};

window_t							/* EChE` */
	mainWin = {&mainDraw, (window *) NULL, (window *) -1, {0, 0, 320, 112},
		"\@Sound Player SX-68K", 0, (49 << 4), 0b0001};

/* {^pC[W̃|C^ */
rectImg **pImgPlayButton;			/* Đ{^ */
rectImg **pImgStopButton;			/* ~{^ */
rectImg **pImgNextButton;			/* ȃ{^ */
rectImg	**pImgBeforeButton;			/* Oȃ{^ */
rectImg **pImgRandomButton;			/* _{^ */
rectImg **pImgPauseButton;			/* ꎞ~{^ */
rectImg **pImgRestartButton;		/* ĊJ{^ */
rectImg **pImgDisRndButton;			/* _{^ */
rectImg **pImgPushPlayButton;		/* Đ{^ */
rectImg **pImgPushStopButton;		/* ~{^ */
rectImg **pImgPushNextButton;		/* ȃ{^ */
rectImg **pImgPushBeforeButton;		/* Oȃ{^ */
rectImg **pImgPushRndButton;		/* _{^ */
rectImg **pImgPushPauseButton;		/* ꎞ~{^ */
rectImg **pImgPushRestartButton;	/* ĊJ{^ */
rectImg	**pImgPushDisRndButton;		/* _{^ */

rectImg **pImageH[5];		/* C[W{^ziʏ{^j     */
rectImg **pImageL[5];		/* @@@@@@@@@iĂ鎞j */


point_t	astButtonPoint[5] = {			/* {^̈ʒu */
					Point_t(264,80),	/* Đ */
					Point_t(216,80),	/* ~ */
					Point_t(136,80),	/*  */
					Point_t( 88,80),	/* O */
					Point_t(  8,80) };	/* _ */

m_picbtn_t	stCtrlButton = {
							pImageH,
							pImageL,
							astButtonPoint,
							5,
							0x00,
							Rect(0, 0, 0, 0),
							NULL,
							NULL,
							0 };

method_t	mFileDrop = {
							NULL,
							m_DRPDWN,
							NULL,
							iFileDrop };

method_t	mCtrlButton = {
							&mFileDrop, 
							m_PICBTN,
							&stCtrlButton,
							NULL};



extern int	iPlayTime;

extern int	iPlayTrack;

extern uchar	*pcPlayTitle;

extern	stPlayList_t	stPlayList;

extern int	iPlayMode;				/* Đ		PLAY_NORMAL				*/
									/* 				PLAY_RANDOM				*/

int MainDraw()						/* `֐` */
{
	graph *grp = PtrA0(GMExgGraph(&mainWin.wptr->wGraph));
	rect	stRect;
	int 	iFontKind;

	iFontKind  = GMFontKind(1);			/* 16x16 dot Font */

	stRect.top = 8;
	stRect.left = 9;

	stRect.right=311;
	stRect.bottom = 71;

	ULD3Rect2( &stRect );


	GMPenMode(0);
	GMShadowStrZ( "Track", Point_t(120, 48) );
	GMShadowStrZ( "Time", Point_t(224, 48) );

	GMFontKind(iFontKind);

	GMExgGraph(grp);					/* Ot|[g߂ */

	iDrawPlayTime();
	iDrawTrack();
	iDrawTitle();

	return 0;
}


int	iDrawPlayTime()
{
	int		iTenMin;
	int		iMin;
	int		iTenSec;
	int		iSec;
	graph *grp = PtrA0(GMExgGraph(&mainWin.wptr->wGraph));
	int kind = GMFontKind(1);

	iTenMin = iPlayTime / 600;
	iMin = (iPlayTime / 60) - (iTenMin * 10);
	iTenSec = (iPlayTime % 60) / 10;
	iSec = iPlayTime % 10;

	GMPenMode(0);
	GMFontMode(0);

	GMMove(Point_t(264, 48));
	GMDrawChar('0'+iTenMin);
	GMDrawChar('0'+iMin);
	GMDrawChar(':');
	GMDrawChar('0'+iTenSec);
	GMDrawChar('0'+iSec);


	GMFontKind(kind);
	GMExgGraph(grp);					/* Ot|[g߂ */

	return 0;
}

int	iDrawTrack()
{
	int	iTenTrack;
	int	iTrack;

	graph *grp = PtrA0(GMExgGraph(&mainWin.wptr->wGraph));
	int kind;

	kind  = GMFontKind(0);

	iTenTrack = iPlayTrack / 10;
	iTrack = iPlayTrack % 10;

	GMPenMode(0);
	GMFontMode(0);

	if ( iPlayMode == PLAY_RANDOM ) {
		GMMove(Point_t(40,52));
		GMDrawChar('R');
		GMDrawChar('A');
		GMDrawChar('N');
		GMDrawChar('D');
		GMDrawChar('O');
		GMDrawChar('M');
	}
	else {
		GMMove(Point_t(40,52));
		GMDrawChar(' ');
		GMDrawChar(' ');
		GMDrawChar(' ');
		GMDrawChar(' ');
		GMDrawChar(' ');
		GMDrawChar(' ');
	}

	GMFontKind(1);

	GMMove(Point_t(168, 48));
	GMDrawChar('0'+iTenTrack);
	GMDrawChar('0'+iTrack);


	iTenTrack = stPlayList.iMusicCount / 10;
	iTrack = stPlayList.iMusicCount % 10;
	GMDrawChar('/');
	GMDrawChar('0'+iTenTrack);
	GMDrawChar('0'+iTrack);


	GMFontKind(kind);
	GMExgGraph(grp);					/* Ot|[g߂ */

	return 0;
}

iDrawTitle() {
	graph *grp = PtrA0(GMExgGraph(&mainWin.wptr->wGraph));
	int kind;

	GMPenMode(0);
	GMFontMode(0);

	kind  = GMFontKind(2);

	GMMove(Point_t(16,16));
	ULDrawStrCenterL("\@                        \0",24);

	if ( pcPlayTitle == NULL ) {	/* ^Cgݒ̏ꍇ */
		GMMove(Point_t(16,16));

		ULDrawStrCenterL("\@----- NO TITLE -----\0",24);

	}
	else {
		if ( strlen(pcPlayTitle) <= 25 ) {

			GMMove(Point_t(16,16));

			ULDrawStrCenterL(pcPlayTitle,24);
		}
		else {
			GMFontKind(1);
			GMMove(Point_t(16,20));

			ULDrawStrCenterL(pcPlayTitle,36);
		}
	}

	GMFontKind(kind);
	GMExgGraph(grp);

	return 0;
}
